package com.zcloud.controller.task;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.task.CourseStudyService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：课程学习
 * 作者：luoxiaobao
 * 时间：2021-09-16
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/app/coursestudy")
public class AppCourseStudyController extends BaseController {

	@Autowired
	private CourseStudyService coursestudyService;


	/**结束本次学习，保存学习习题
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/submit")
//	// @RequiresPermissions( value = {"coursestudy:edit", "curriculum:edit"}, logical = Logical.OR)
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "结束本次学习，保存学习习题")
	public Object submit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String nowDate = DateUtil.date2Str(new Date());
		pd.put("COURSESTUDY_ID", this.get32UUID());	//主键
		pd.put("CURRICULUM_ID", pd.getString("CURRICULUMID"));
		pd.put("STUDYQUESTIONNUM", "0");	//本次学习总题数
		pd.put("STUDYQUESTIONRIGHT", "0");	//学习对题数
		pd.put("STUDYQUESTIONWRONG", "0");	//学习错题数
//		pd.put("USER_ID", pd.getString("USER_ID"));	//添加人
		pd.put("CREATOR", pd.getString("USERNAME"));	//添加人
		pd.put("CREATTIME", nowDate);	//添加时间
		pd.put("OPERATOR", pd.getString("USERNAME"));	//修改人
		pd.put("OPERATTIME", nowDate);	//修改时间
		pd.put("ISDELETE", "0");	//是否删除(0:有效 1：删除)
		pd.put("CORPINFO_ID", pd.getString("CORPINFO_ID"));	//企业ID

		pd = coursestudyService.submit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}




























	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
//	// @RequiresPermissions("coursestudy:add")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "新增")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("COURSESTUDY_ID", this.get32UUID());	//主键
		String nowDate = DateUtil.date2Str(new Date());
		pd.put("STUDYTIME", nowDate);	//学习时间
		pd.put("STUDYQUESTIONNUM", "0");	//本次学习总题数
		pd.put("STUDYQUESTIONRIGHT", "0");	//学习对题数
		pd.put("STUDYQUESTIONWRONG", "0");	//学习错题数
		pd.put("USER_ID", Jurisdiction.getUSER_ID());	//添加人
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", nowDate);	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", nowDate);	//修改时间
		pd.put("ISDELETE", "0");	//是否删除(0:有效 1：删除)
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		coursestudyService.save(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
//	// @RequiresPermissions("coursestudy:del")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "删除")
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		coursestudyService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("coursestudy:edit")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "修改")
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		coursestudyService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("coursestudy:list")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = coursestudyService.list(page);	//列出CourseStudy列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("coursestudy:edit")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = coursestudyService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("coursestudy:del")
	@ResponseBody
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "批量删除")
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String[] ArrayDATA_IDS = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			coursestudyService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	@LogAnno(menuType= "手机",menuServer= "课程学习",instructionsOperate = "课程学习",instructionsType = "导出到excel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("课程ID");	//1
		titles.add("学员ID");	//2
		titles.add("学习时间");	//3
		titles.add("学习总题数");	//4
		titles.add("学习对题数");	//5
		titles.add("学习错题数");	//6
		titles.add("添加人");	//7
		titles.add("添加时间");	//8
		titles.add("修改人");	//9
		titles.add("修改时间");	//10
		titles.add("是否删除(0:有效 1：删除)");	//11
		titles.add("企业ID");	//12
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = coursestudyService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("CURRICULUM_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("USER_ID"));	    //2
			vpd.put("var3", varOList.get(i).getString("STUDYTIME"));	    //3
			vpd.put("var4", varOList.get(i).getString("STUDYQUESTIONNUM"));	    //4
			vpd.put("var5", varOList.get(i).getString("STUDYQUESTIONRIGHT"));	    //5
			vpd.put("var6", varOList.get(i).getString("STUDYQUESTIONWRONG"));	    //6
			vpd.put("var7", varOList.get(i).getString("CREATOR"));	    //7
			vpd.put("var8", varOList.get(i).getString("CREATTIME"));	    //8
			vpd.put("var9", varOList.get(i).getString("OPERATOR"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATTIME"));	    //10
			vpd.put("var11", varOList.get(i).getString("ISDELETE"));	    //11
			vpd.put("var12", varOList.get(i).getString("CORPINFO_ID"));	    //12
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
